package heap;

// The heapsort algorithm - class HeapsortArray.

// This implementation is modeled after the courseware Heapsort-SALA.
// http://OLLI.Informatik.Uni-Oldenburg.DE/heapsort_SALA/
// It is optimized for easy understanding and not for efficiency.
// (c) 2001 Nils Faltin. Distributed under the GNU General Public License. 
// The license text ist contained in the courseware distribution.

 
// Sorts an array of node keys with the heapsort algorithm
public class HeapsortArray extends HeapArray {  
   
	// class methods
   // constructor: initialize with empty array of length len
	public HeapsortArray(int len){
	  super(len);
	}
	
   
  // instance methods

   // algorithm functions
    
   // Sort the input keys in increasing order
   // This is the entry function for the heapsort algorithm
   public void heapsort(){
     buildHeap();
     sort();
   }

	// move all Nodes in decreasing key size order into the result list
	// precondition: the tree must be a heap
   protected void sort(){
     while (!heapEmpty()){
       moveMax();
     }
   }
   
   
}
