package heap;

// A Priority Queue using a Heap - class PriorityQueueTester.

// This implementation is modeled after the courseware Heapsort-SALA.
// http://OLLI.Informatik.Uni-Oldenburg.DE/heapsort_SALA/
// It is optimized for easy understanding and not for efficiency.
// (c) 2001 Nils Faltin. Distributed under the GNU General Public License. 
// The license text ist contained in the courseware distribution.

public class PriorityQueueTester {  

	public static void main (String [] args) {
		testPriorityQueue1(); // test algorithm
	}
	

	// test changeKey function 1
	static void testPriorityQueue1(){
	  PriorityQueue pq = new PriorityQueue(10);

	  output("Test PriorityQueue1");
	  output("Expected / Received");
	  
	  pq.addNode(new IntNode(3));
	  Node n3= pq.getMaxNode();
	  output("3 /" + n3);
	  
	  pq.addNode(new IntNode(5));
	  pq.addNode(new IntNode(2));
	  IntNode n5= (IntNode)pq.getMaxNode();
	  output("5 / " + n5);
	  IntNode n2= (IntNode)pq.getMaxNode();
	  output("2 / " + n2);
	  
	  pq.addNode(new IntNode(4));
	  pq.addNode(new IntNode(7));
	  output("7 / " + pq.getMaxNode());
	  output("4 / " + pq.getMaxNode());
	  
	}
	
	static void output(Object s){
	  System.out.println(s.toString());
	}
}	
